<?php
namespace Magenest\Salesforce\Controller\Adminhtml\Queue;

use Magenest\Salesforce\Model\Queue;

/**
 * Class Lead
 * @package Magenest\Salesforce\Controller\Adminhtml\Queue
 */
class Lead extends \Magenest\Salesforce\Controller\Adminhtml\Queue\AbstractionAction
{
    /** @var string */
    protected $type = Queue::TYPE_LEAD;

    /**
     * @return \Magento\Framework\Controller\ResultInterface|void
     */
    public function execute()
    {
        if ($this->getRequest()->isAjax()) {
            $customerCollection = $this->customerCollection->create()->addFieldToSelect('entity_id');
            try {
                $ids = $this->getFilterDate($customerCollection)->getAllIds();
                $queueIds = $this->getQueueIdsByType($this->type);
                $this->_queueResource->deleteMultiQueues($queueIds);
                $this->publishData($ids, $this->type);
                $this->getResponse()->setBody($this->_json->serialize([
                    'error'   => 0,
                    'message' => __('All Leads are being added to queue.'),
                ]));
                return;
            } catch (\Throwable $e) {
                $this->_logger->critical($e->getMessage());
                $this->getResponse()->setBody($this->_json->serialize([
                    'error'   => 0,
                    'message' => __('Something went wrong while adding record(s) to queue. Error: ' . $e->getMessage()),
                ]));
                return;
            }
        }
        return $this->_redirect('*/*/index');
    }

    /**
     * @param $customerId
     *
     * @return \Magento\Sales\Model\ResourceModel\Order\Collection
     */
    protected function getCustomerOrderCollection($customerId)
    {
        return $this->_helperData->getCustomerOrderCollection($customerId);
    }
}
